/* #include <winspool.h> */
#include <ddk/compstui.h> /* common props sheet ui */
/*#include <winddi.h>
#include <winddiui.h>*/
#ifndef HEX_PER_LINE
#define HEX_PER_LINE 24
#endif

char *decodeError(DWORD errorcode, char *buffer);


VOID dump_hex(LPVOID base, DWORD size)
{
	LPSTR	ptr;
	LPSTR	fmt;
	DWORD	len;
	DWORD	offset = 0;
	len = size - (size & (HEX_PER_LINE -1) );
	fmt = 	(len > 99999) ? "%p (0x%05lx/%06ld): " : \
	 	(len > 65536) ? "%p (0x%05lx/%05ld): " : \
	 	(len >  9999) ? "%p (0x%04lx/%05ld): " : \
		(len >  4096) ? "%p (0x%04lx/%04ld): " : \
		(len >   999) ? "%p (0x%03lx/%04ld): " : \
		(len >   256) ? "%p (0x%03lx/%03ld): " : \
		(len >    99) ? "%p (0x%02lx/%03ld): " : \
				"%p (0x%02lx/%02ld): ";
	ptr = (LPSTR) base;
	printf("%p (size: 0x%x/%d)\r\n", ptr, size, size);	
	while (size > 0) {
		offset = ptr - (LPSTR) base;
		printf(fmt, ptr, offset, offset);
		len = min(size, HEX_PER_LINE);
		while (len > 0) {
			offset++;
			printf("%02x%s", (int) (*ptr & 0xff), ((offset & 3) == 0) ? " " : "");
			len--;
			ptr++;
		}
		len = min(size, HEX_PER_LINE);
		while (len < HEX_PER_LINE) {
			offset++;
			printf("  %s", ((offset & 3) == 0) ? " " : "");
			len++;
		}
		printf(": ");
		len = min(size, HEX_PER_LINE);
		ptr -= len;
		offset = ptr - (LPSTR) base;
		while (len > 0) {
			offset++;
			printf("%c%s", isprint((int) (*ptr & 0xff)) ? (int) (*ptr & 0xff) :  '.',
				 ((offset & 3) == 0) ? " " : "");
			len--;
			ptr++;
		}
		printf("\r\n");
		len = min(size, HEX_PER_LINE);
		size -= len;
	}
}

static LPWSTR strdupAtoW(LPCSTR str)
{
    LPWSTR ret = NULL;
    if (str)
    {
        DWORD len = MultiByteToWideChar( CP_ACP, 0, str, -1, NULL, 0 );
        if ((ret = HeapAlloc( GetProcessHeap(), 0, len * sizeof(WCHAR) )))
            MultiByteToWideChar( CP_ACP, 0, str, -1, ret, len );
    }
    return ret;
}

static LPSTR strdupWtoA(LPCWSTR str)
{
    LPSTR ret = NULL;
    if (str){
        DWORD len = WideCharToMultiByte( CP_ACP, 0, str, -1, NULL, 0, NULL, NULL );
        if ((ret = HeapAlloc( GetProcessHeap(), 0, len )))
            WideCharToMultiByte( CP_ACP, 0, str, -1, ret, len, NULL, NULL );
    }
    return ret;
}

VOID dumpmemory(VOID *mem, INT size, CHAR *memname) {
    INT i;
    BYTE databyte;
#define output stdout
    fprintf(output,"dumping %s with size of %d Bytes..\r\n", memname, size);
    for (i=0; i<size; i++){
        databyte = *((BYTE*)mem+i);
        fprintf(output,"%02X", databyte);
        if (i%2==1) fprintf(output, " ");
        if (i%32==31) if (i<size-1) fprintf(output,"\r\n");
    }
    fprintf(output,"\r\n\r\n");
    fflush(output);
}

VOID dumpdriverinfo2(PDRIVER_INFO_2 drvinfo){
    printf("---------------------------------------------\r\n");
    printf("dumping DRIVER_INFO_2 structure... {\r\n");
    printf("\tDWORD drvinfo.cVersion = %d\r\n", drvinfo->cVersion);
    printf("\tLPTSTR drvinfo.pName = %s\r\n", drvinfo->pName);
    printf("\tLPTSTR drvinfo.pEnvironment = %s\r\n", drvinfo->pEnvironment);
    printf("\tLPTSTR drvinfo.pDriverPath = %s\r\n", drvinfo->pDriverPath);
    printf("\tLPTSTR drvinfo.pDataFile = %s\r\n", drvinfo->pDataFile);
    printf("\tLPTSTR drvinfo.pConfigFile = %s\r\n", drvinfo->pConfigFile);
    printf("} -------------------------------------------\r\n");
    fflush(stdout);
}

VOID dumpdocpropheader(PDOCUMENTPROPERTYHEADER docpropheader){
    printf("---------------------------------------------\r\n");
    printf("dumping DOCUMENTPROPERTYHEADER structure... {\r\n");
    printf("\tWORD cbSize = %d\r\n", docpropheader->cbSize);
    printf("\tWORD Reserved = %d\r\n", docpropheader->Reserved);
    printf("\tHANDLE hPrinter = %p\r\n", docpropheader->hPrinter);
    printf("\tLPTSTR pszPrinterName = %p => %s\r\n", docpropheader->pszPrinterName, docpropheader->pszPrinterName);
    printf("\tPDEVMODE pdmIn = %p\r\n", docpropheader->pdmIn);
    printf("\tPDEVMODE pdmOut = %p\r\n", docpropheader->pdmOut);
    printf("\tDWORD cbOut = %d\r\n", docpropheader->cbOut);
    printf("\tDWORD fMode = %d\r\n", docpropheader->fMode);
    printf("} -------------------------------------------\r\n");
    fflush(stdout);
}
VOID dumpsurfobj(SURFOBJ *surfaceobject){
    printf("---------------------------------------------\r\n");
    printf("dumping SURFOBJ structure... {\r\n");
    printf("\t%d Bytes: DHSURF dhsurf = %p\r\n", sizeof(DHSURF), surfaceobject->dhsurf);
    printf("\t%d Bytes: HSURF hsurf = %p\r\n", sizeof(HSURF), surfaceobject->hsurf);
    printf("\t%d Bytes: DHPDEV dhpdev = %p\r\n", sizeof(DHPDEV), surfaceobject->dhpdev);
    printf("\t%d Bytes: HDEV hdev = %p\r\n", sizeof(HDEV), surfaceobject->hdev);
    printf("\t%d Bytes: SIZEL sizlBitmap = %d x %d\r\n", sizeof(SIZEL), surfaceobject->sizlBitmap.cx, surfaceobject->sizlBitmap.cy);
    printf("\t%d Bytes: ULONG cjBits = %d\r\n", sizeof(ULONG), surfaceobject->cjBits);
    printf("\t%d Bytes: PVOID pvBits = %p\r\n", sizeof(PVOID), surfaceobject->pvBits);
    printf("\t%d Bytes: PVOID pvScan0 = %p\r\n", sizeof(PVOID), surfaceobject->pvScan0);
    printf("\t%d Bytes: LONG lDelta = %d\r\n", sizeof(LONG), surfaceobject->lDelta);
    printf("\t%d Bytes: ULONG iUniq = %u\r\n", sizeof(ULONG), surfaceobject->iUniq);
    printf("\t%d Bytes: ULONG iBitmapFormat = %u\r\n", sizeof(ULONG), surfaceobject->iBitmapFormat);
    printf("\t%d Bytes: USHORT iType = %u\r\n", sizeof(USHORT), surfaceobject->iType);
    printf("\t%d Bytes: USHORT fjBitmap = %u\r\n", sizeof(USHORT), surfaceobject->fjBitmap);
    printf("} -------------------------------------------\r\n");
    fflush(stdout);
}


VOID dumpdevmode(PDEVMODEW devmode){
    printf("---------------------------------------------\r\n");
    printf("dumping DEVMODE structure...{\r\n");
    printf("\tWCHAR dmDeviceName = \"%s\"\r\n", strdupWtoA(devmode->dmDeviceName));
    printf("\tWORD dmSpecVersion = 0x%x\r\n", devmode->dmSpecVersion);
    printf("\tWORD dmDriverVersion = %d\r\n", devmode->dmDriverVersion);
    printf("\tWORD dmSize = %d\r\n", devmode->dmSize);
    printf("\tWORD dmDriverExtra = %d\r\n", devmode->dmDriverExtra);
    printf("\tDWORD dmFields = 0x%x\r\n", devmode->dmFields);
    printf("\tshort dmOrientation = %d\r\n", devmode->dmOrientation);
    printf("\tshort dmPaperSize = %d\r\n", devmode->dmPaperSize);
    printf("\tshort dmPaperLength = %d\r\n", devmode->dmPaperLength);
    printf("\tshort dmPaperWidth = %d\r\n", devmode->dmPaperWidth);
    printf("\tshort dmScale = %d\r\n", devmode->dmScale);
    printf("\tshort dmCopies = %d\r\n", devmode->dmCopies);
    printf("\tshort dmDefaultSource = %d\r\n", devmode->dmDefaultSource);
    printf("\tshort dmPrintQuality = %d\r\n", devmode->dmPrintQuality);
/*     some fields missing here! */
    printf("\tshort dmColor = %d\r\n", devmode->dmColor);
    printf("\tshort dmDuplex = %d\r\n", devmode->dmDuplex);
    printf("\tshort dmYResolution = %d\r\n", devmode->dmYResolution);
    printf("\tshort dmTTOption = %d\r\n", devmode->dmTTOption);
    printf("\tshort dmCollate = %d\r\n", devmode->dmCollate);
    printf("\tWCHAR dmFormName = \"%s\"\r\n", strdupWtoA(devmode->dmFormName));
    printf("\tWORD dmLogPixels = %d\r\n", devmode->dmLogPixels);
    printf("\tDWORD dmBitsPerPel = %d\r\n", devmode->dmBitsPerPel);
    printf("\tDWORD dmPelsWidth = %d\r\n", devmode->dmPelsWidth);
    printf("\tDWORD dmPelsHeight = %d\r\n", devmode->dmPelsHeight);
    printf("\tDWORD dmDisplayFlags = %d\r\n", devmode->dmDisplayFlags);
/*     some more fields missing */
    printf("} -------------------------------------------\r\n");
    fflush(stdout);
}

VOID dumpDevInfo(PDEVINFO devinfo) {
    printf("---------------------------------------------\r\n");
    printf("dumping DEVINFO structure... {\r\n");
    printf("\tFLONG flGraphicsCaps = 0x%08x\r\n", devinfo->flGraphicsCaps);
/*    printf("\tLOGFONTW lfDefaultFont = %x\r\n", devinfo->lfDefaultFont);
    printf("\tLOGFONTW lfAnsiVarFont = %x\r\n", devinfo->lfAnsiVarFont);
    printf("\tLOGFONTW lfAnsiFixFont = %x\r\n", devinfo->lfAnsiFixFont);*/
    printf("\tULONG cFonts = %d\r\n", devinfo->cFonts);
    printf("\tULONG iDitherFormat = %d\r\n", devinfo->iDitherFormat);
    printf("\tUSHORT cxDither = %d\r\n", devinfo->cxDither);
    printf("\tUSHORT cyDither = %d\r\n", devinfo->cyDither);
    printf("\tHPALETTE hpalDefault = %p\r\n", devinfo->hpalDefault);
    printf("\tFLONG flGraphicsCaps2 = %d\r\n", devinfo->flGraphicsCaps2);
    printf("} -------------------------------------------\r\n");
    fflush(stdout);
}

VOID dumpGdiInfo(PGDIINFO gdiinfo) {
    printf("---------------------------------------------\r\n");
    printf("dumping GDIINFO structure... {\r\n");
    printf("\tULONG ulVersion = %d\r\n", gdiinfo->ulVersion);
    printf("\tULONG ulTechnology = %d\r\n", gdiinfo->ulTechnology);
    printf("\tULONG ulHorzSize = %d\r\n", gdiinfo->ulHorzSize);
    printf("\tULONG ulVertSize = %d\r\n", gdiinfo->ulVertSize);
    printf("\tULONG ulHorzRes = %d\r\n", gdiinfo->ulHorzRes);
    printf("\tULONG ulVertRes = %d\r\n", gdiinfo->ulVertRes);
    printf("\tULONG cBitsPixel = %d\r\n", gdiinfo->cBitsPixel);
    printf("\tULONG cPlanes = %d\r\n", gdiinfo->cPlanes);
    printf("\tULONG ulNumColors = %d\r\n", gdiinfo->ulNumColors);
    printf("\tULONG flRaster = %d\r\n", gdiinfo->flRaster);
    printf("\tULONG ulLogPixelsX = %d\r\n", gdiinfo->ulLogPixelsX);
    printf("\tULONG ulLogPixelsY = %d\r\n", gdiinfo->ulLogPixelsY);
    printf("\tULONG flTextCaps = %d\r\n", gdiinfo->flTextCaps);
    printf("\tULONG ulDACRed = %d\r\n", gdiinfo->ulDACRed);
    printf("\tULONG ulDACGreen = %d\r\n", gdiinfo->ulDACGreen);
    printf("\tULONG ulDACBlue = %d\r\n", gdiinfo->ulDACBlue);
    printf("\tULONG ulAspectX = %d\r\n", gdiinfo->ulAspectX);
    printf("\tULONG ulAspectY = %d\r\n", gdiinfo->ulAspectY);
    printf("\tULONG ulAspectXY = %d\r\n", gdiinfo->ulAspectXY);
    printf("\tLONG xStyleStep = %d\r\n", gdiinfo->xStyleStep);
    printf("\tLONG yStyleStep = %d\r\n", gdiinfo->yStyleStep);
    printf("\tLONG denStyleStep = %d\r\n", gdiinfo->denStyleStep);
/*     printf("\tPOINTL ptlPhysOffset; */
    printf("\tSIZEL szlPhysSize = %d x %d\r\n", gdiinfo->szlPhysSize.cx, gdiinfo->szlPhysSize.cy);
    printf("\tULONG ulNumPalReg = %d\r\n", gdiinfo->ulNumPalReg);
/*     printf("\tCOLORINFO ciDevice; */
    printf("\tULONG ulDevicePelsDPI = %d\r\n", gdiinfo->ulDevicePelsDPI);
    printf("\tULONG ulPrimaryOrder = %d\r\n", gdiinfo->ulPrimaryOrder);
    printf("\tULONG ulHTPatternSize = %d\r\n", gdiinfo->ulHTPatternSize);
    printf("\tULONG ulHTOutputForm = %d\r\n", gdiinfo->ulHTOutputForm);
    printf("\tULONG flHTFlags = %d\r\n", gdiinfo->flHTFlags);
    printf("\tULONG ulVRefresh = %d\r\n", gdiinfo->ulVRefresh);
    printf("\tULONG ulBltAlignment = %d\r\n", gdiinfo->ulBltAlignment);
    printf("\tULONG ulPanningHorzRes = %d\r\n", gdiinfo->ulPanningHorzRes);
    printf("\tULONG ulPanningVertRes = %d\r\n", gdiinfo->ulPanningVertRes);
    printf("\tULONG xPanningAlignment = %d\r\n", gdiinfo->xPanningAlignment);
    printf("\tULONG yPanningAlignment = %d\r\n", gdiinfo->yPanningAlignment);
    printf("\tULONG cxHTPat = %d\r\n", gdiinfo->cxHTPat);
    printf("\tULONG cyHTPat = %d\r\n", gdiinfo->cyHTPat);
    printf("\tLPBYTE pHTPatA = %p\r\n", gdiinfo->pHTPatA);
    printf("\tLPBYTE pHTPatB = %p\r\n", gdiinfo->pHTPatB);
    printf("\tLPBYTE pHTPatC = %p\r\n", gdiinfo->pHTPatC);
    printf("\tULONG flShadeBlend = %d\r\n", gdiinfo->flShadeBlend);
    printf("\tULONG ulPhysicalPixelCharacteristics = %d\r\n", gdiinfo->ulPhysicalPixelCharacteristics);
    printf("\tULONG ulPhysicalPixelGamma = %d\r\n", gdiinfo->ulPhysicalPixelGamma);
    printf("} -------------------------------------------\r\n");
    fflush(stdout);
}

/*VOID dumpPalette(HPALETTE hpalette) {
    UINT iEntriesReceived = 0;
    int i;
    char errorbuffer[100];
    PALETTEENTRY PaletteEntries[2560];

    SetLastError(ERROR_SUCCESS);
    iEntriesReceived = GetPaletteEntries(hpalette, 1, 2550, PaletteEntries);
    if (iEntriesReceived < 1)
    {
        printf("couldn't get palette entries from HPALETTE 0x%x with LastError() = %d (%s)\r\n", hpalette, GetLastError(), decodeError(GetLastError(), errorbuffer));
        fflush(stdout);
        return;
    }
    printf("---------------------------------------------\r\n");
    printf("dumping HPALETTE 0x%x... {\r\n", hpalette);
    for (i = 0; i < iEntriesReceived; i++)
    {
        printf("Red = 0x%x, Green = 0x%x, Blue = 0x%x, Flags = %d\r\n", PaletteEntries[i].peRed, PaletteEntries[i].peGreen, PaletteEntries[i].peBlue, PaletteEntries[i].peFlags);
    }
    printf("} -------------------------------------------\r\n");
    fflush(stdout);
}*/

#define ERRORISIF(name, number) if ( errorcode == number ) strcpy(buffer, #name)
char *decodeError(DWORD errorcode, char *buffer){
    strcpy(buffer, "THIS_ERROR_NOT_YET_IMPLEMENTED");
    ERRORISIF(ERROR_SUCCESS,0);
    ERRORISIF(ERROR_INVALID_FUNCTION,1);
    ERRORISIF(ERROR_FILE_NOT_FOUND,2);
    ERRORISIF(ERROR_PATH_NOT_FOUND,3);
    ERRORISIF(ERROR_TOO_MANY_OPEN_FILES,4);
    ERRORISIF(ERROR_ACCESS_DENIED,5);
    ERRORISIF(ERROR_INVALID_HANDLE,6);
    ERRORISIF(ERROR_ARENA_TRASHED,7);
    ERRORISIF(ERROR_NOT_ENOUGH_MEMORY,8);
    ERRORISIF(ERROR_INVALID_BLOCK,9);
    ERRORISIF(ERROR_BAD_ENVIRONMENT,10);
    ERRORISIF(ERROR_BAD_FORMAT,11);
    ERRORISIF(ERROR_INVALID_ACCESS,12);
    ERRORISIF(ERROR_INVALID_DATA,13);
    ERRORISIF(ERROR_OUTOFMEMORY,14);
    ERRORISIF(ERROR_INVALID_DRIVE,15);
    ERRORISIF(ERROR_CURRENT_DIRECTORY,16);
    ERRORISIF(ERROR_NOT_SAME_DEVICE,17);
    ERRORISIF(ERROR_NO_MORE_FILES,18);
    ERRORISIF(ERROR_WRITE_PROTECT,19);
    ERRORISIF(ERROR_BAD_UNIT,20);
    ERRORISIF(ERROR_NOT_READY,21);
    ERRORISIF(ERROR_BAD_COMMAND,22);
    ERRORISIF(ERROR_CRC,23);
    ERRORISIF(ERROR_BAD_LENGTH,24);
    ERRORISIF(ERROR_SEEK,25);
    ERRORISIF(ERROR_NOT_DOS_DISK,26);
    ERRORISIF(ERROR_SECTOR_NOT_FOUND,27);
    ERRORISIF(ERROR_OUT_OF_PAPER,28);
    ERRORISIF(ERROR_WRITE_FAULT,29);
    ERRORISIF(ERROR_READ_FAULT,30);
    ERRORISIF(ERROR_GEN_FAILURE,31);
    ERRORISIF(ERROR_SHARING_VIOLATION,32);
    ERRORISIF(ERROR_LOCK_VIOLATION,33);
    ERRORISIF(ERROR_WRONG_DISK,34);
    ERRORISIF(ERROR_UNKNOWN_NAME_01,35);
    ERRORISIF(ERROR_SHARING_BUFFER_EXCEEDED,36);
    ERRORISIF(ERROR_HANDLE_EOF,38);
    ERRORISIF(ERROR_HANDLE_DISK_FULL,39);
    ERRORISIF(ERROR_NOT_SUPPORTED,50);
    ERRORISIF(ERROR_REM_NOT_LIST,51);
    ERRORISIF(ERROR_DUP_NAME,52);
    ERRORISIF(ERROR_BAD_NETPATH,53);
    ERRORISIF(ERROR_NETWORK_BUSY,54);
    ERRORISIF(ERROR_DEV_NOT_EXIST,55);
    ERRORISIF(ERROR_TOO_MANY_CMDS,56);
    ERRORISIF(ERROR_ADAP_HDW_ERR,57);
    ERRORISIF(ERROR_BAD_NET_RESP,58);
    ERRORISIF(ERROR_UNEXP_NET_ERR,59);
    ERRORISIF(ERROR_BAD_REM_ADAP,60);
    ERRORISIF(ERROR_PRINTQ_FULL,61);
    ERRORISIF(ERROR_NO_SPOOL_SPACE,62);
    ERRORISIF(ERROR_PRINT_CANCELLED,63);
    ERRORISIF(ERROR_NETNAME_DELETED,64);
    ERRORISIF(ERROR_NETWORK_ACCESS_DENIED,65);
    ERRORISIF(ERROR_BAD_DEV_TYPE,66);
    ERRORISIF(ERROR_BAD_NET_NAME,67);
    ERRORISIF(ERROR_TOO_MANY_NAMES,68);
    ERRORISIF(ERROR_TOO_MANY_SESS,69);
    ERRORISIF(ERROR_SHARING_PAUSED,70);
    ERRORISIF(ERROR_REQ_NOT_ACCEP,71);
    ERRORISIF(ERROR_REDIR_PAUSED,72);
    ERRORISIF(ERROR_FILE_EXISTS,80);
    ERRORISIF(ERROR_CANNOT_MAKE,82);
    ERRORISIF(ERROR_FAIL_I24,83);
    ERRORISIF(ERROR_OUT_OF_STRUCTURES,84);
    ERRORISIF(ERROR_ALREADY_ASSIGNED,85);
    ERRORISIF(ERROR_INVALID_PASSWORD,86);
    ERRORISIF(ERROR_INVALID_PARAMETER,87);
    ERRORISIF(ERROR_NET_WRITE_FAULT,88);
    ERRORISIF(ERROR_NO_PROC_SLOTS,89);
    ERRORISIF(ERROR_TOO_MANY_SEMAPHORES,100);
    ERRORISIF(ERROR_EXCL_SEM_ALREADY_OWNED,101);
    ERRORISIF(ERROR_SEM_IS_SET,102);
    ERRORISIF(ERROR_TOO_MANY_SEM_REQUESTS,103);
    ERRORISIF(ERROR_INVALID_AT_INTERRUPT_TIME,104);
    ERRORISIF(ERROR_SEM_OWNER_DIED,105);
    ERRORISIF(ERROR_SEM_USER_LIMIT,106);
    ERRORISIF(ERROR_DISK_CHANGE,107);
    ERRORISIF(ERROR_DRIVE_LOCKED,108);
    ERRORISIF(ERROR_BROKEN_PIPE,109);
    ERRORISIF(ERROR_OPEN_FAILED,110);
    ERRORISIF(ERROR_BUFFER_OVERFLOW,111);
    ERRORISIF(ERROR_DISK_FULL,112);
    ERRORISIF(ERROR_NO_MORE_SEARCH_HANDLES,113);
    ERRORISIF(ERROR_INVALID_TARGET_HANDLE,114);
    ERRORISIF(ERROR_INVALID_CATEGORY,117);
    ERRORISIF(ERROR_INVALID_VERIFY_SWITCH,118);
    ERRORISIF(ERROR_BAD_DRIVER_LEVEL,119);
    ERRORISIF(ERROR_CALL_NOT_IMPLEMENTED,120);
    ERRORISIF(ERROR_SEM_TIMEOUT,121);
    ERRORISIF(ERROR_INSUFFICIENT_BUFFER,122);
    ERRORISIF(ERROR_INVALID_NAME,123);
    ERRORISIF(ERROR_INVALID_LEVEL,124);
    ERRORISIF(ERROR_NO_VOLUME_LABEL,125);
    ERRORISIF(ERROR_MOD_NOT_FOUND,126);
    ERRORISIF(ERROR_PROC_NOT_FOUND,127);
    ERRORISIF(ERROR_WAIT_NO_CHILDREN,128);
    ERRORISIF(ERROR_CHILD_NOT_COMPLETE,129);
    ERRORISIF(ERROR_DIRECT_ACCESS_HANDLE,130);
    ERRORISIF(ERROR_NEGATIVE_SEEK,131);
    ERRORISIF(ERROR_SEEK_ON_DEVICE,132);
    ERRORISIF(ERROR_IS_JOIN_TARGET,133);
    ERRORISIF(ERROR_IS_JOINED,134);
    ERRORISIF(ERROR_IS_SUBSTED,135);
    ERRORISIF(ERROR_NOT_JOINED,136);
    ERRORISIF(ERROR_NOT_SUBSTED,137);
    ERRORISIF(ERROR_JOIN_TO_JOIN,138);
    ERRORISIF(ERROR_SUBST_TO_SUBST,139);
    ERRORISIF(ERROR_JOIN_TO_SUBST,140);
    ERRORISIF(ERROR_SUBST_TO_JOIN,141);
    ERRORISIF(ERROR_BUSY_DRIVE,142);
    ERRORISIF(ERROR_SAME_DRIVE,143);
    ERRORISIF(ERROR_DIR_NOT_ROOT,144);
    ERRORISIF(ERROR_DIR_NOT_EMPTY,145);
    ERRORISIF(ERROR_IS_SUBST_PATH,146);
    ERRORISIF(ERROR_IS_JOIN_PATH,147);
    ERRORISIF(ERROR_PATH_BUSY,148);
    ERRORISIF(ERROR_IS_SUBST_TARGET,149);
    ERRORISIF(ERROR_SYSTEM_TRACE,150);
    ERRORISIF(ERROR_INVALID_EVENT_COUNT,151);
    ERRORISIF(ERROR_TOO_MANY_MUXWAITERS,152);
    ERRORISIF(ERROR_INVALID_LIST_FORMAT,153);
    ERRORISIF(ERROR_LABEL_TOO_LONG,154);
    ERRORISIF(ERROR_TOO_MANY_TCBS,155);
    ERRORISIF(ERROR_SIGNAL_REFUSED,156);
    ERRORISIF(ERROR_DISCARDED,157);
    ERRORISIF(ERROR_NOT_LOCKED,158);
    ERRORISIF(ERROR_BAD_THREADID_ADDR,159);
    ERRORISIF(ERROR_BAD_ARGUMENTS,160);
    ERRORISIF(ERROR_BAD_PATHNAME,161);
    ERRORISIF(ERROR_SIGNAL_PENDING,162);
    ERRORISIF(ERROR_MAX_THRDS_REACHED,164);
    ERRORISIF(ERROR_LOCK_FAILED,167);
    ERRORISIF(ERROR_BUSY,170);
    ERRORISIF(ERROR_CANCEL_VIOLATION,173);
    ERRORISIF(ERROR_ATOMIC_LOCKS_NOT_SUPPORTED,174);
    ERRORISIF(ERROR_INVALID_SEGMENT_NUMBER,180);
    ERRORISIF(ERROR_INVALID_ORDINAL,182);
    ERRORISIF(ERROR_ALREADY_EXISTS,183);
    ERRORISIF(ERROR_INVALID_FLAG_NUMBER,186);
    ERRORISIF(ERROR_SEM_NOT_FOUND,187);
    ERRORISIF(ERROR_INVALID_STARTING_CODESEG,188);
    ERRORISIF(ERROR_INVALID_STACKSEG,189);
    ERRORISIF(ERROR_INVALID_MODULETYPE,190);
    ERRORISIF(ERROR_INVALID_EXE_SIGNATURE,191);
    ERRORISIF(ERROR_EXE_MARKED_INVALID,192);
    ERRORISIF(ERROR_BAD_EXE_FORMAT,193);
    ERRORISIF(ERROR_ITERATED_DATA_EXCEEDS_64k,194);
    ERRORISIF(ERROR_INVALID_MINALLOCSIZE,195);
    ERRORISIF(ERROR_DYNLINK_FROM_INVALID_RING,196);
    ERRORISIF(ERROR_IOPL_NOT_ENABLED,197);
    ERRORISIF(ERROR_INVALID_SEGDPL,198);
    ERRORISIF(ERROR_AUTODATASEG_EXCEEDS_64k,199);
    ERRORISIF(ERROR_RING2SEG_MUST_BE_MOVABLE,200);
    ERRORISIF(ERROR_DLL_INIT_FAILED,1114);
    ERRORISIF(ERROR_FILE_CORRUPT,1392);
    ERRORISIF(ERROR_UNKNOWN_PRINTER_DRIVER,1797);
    ERRORISIF(ERROR_INVALID_PRINTER_NAME,1801);
    ERRORISIF(ERROR_RESOURCE_TYPE_NOT_FOUND,1813);
    ERRORISIF(ERROR_SPL_NO_STARTDOC,3003);
    ERRORISIF(BAD_LAST_ERROR_WASNT_SET,0xbad);
    ERRORISIF(2BAD_LAST_ERROR_WASNT_SET,0x2bad);
    ERRORISIF(DEADBEEF_LAST_ERROR_WASNT_SET,0xdeadbeef);
    return(buffer);
}
