/*
 *  Header for the Device Driver Interface - User Interface library
 *
 *  Copyright 2007 Marcel Partap <mpartap@gmx.net>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA
 */

#ifndef __WINE_WINDDIUI_H
#define __WINE_WINDDIUI_H

#ifdef __cplusplus
extern "C" {
#endif

typedef struct _DOCUMENTPROPERTYHEADER {
    WORD cbSize;
    WORD Reserved;
    HANDLE hPrinter;
    LPTSTR pszPrinterName;
    PDEVMODE pdmIn;
    PDEVMODE pdmOut;
    DWORD cbOut;
    DWORD fMode;
} DOCUMENTPROPERTYHEADER, *PDOCUMENTPROPERTYHEADER;

typedef struct _DOCEVENT_CREATEDCPRE {
    PWSTR pszDriver;
    PWSTR pszDevice;
    PDEVMODEW pdm;
    BOOL bIC;
} DOCEVENT_CREATEDCPRE, *PDOCEVENT_CREATEDCPRE;

/* BOOL DDKAPI DrvConvertDevMode(LPTSTR, PDEVMODE, PDEVMODE, PLONG, DWORD); */
typedef BOOL DDKAPI (*PFN_DrvConvertDevMode)(LPTSTR, PDEVMODE, PDEVMODE, PLONG, DWORD);

#define CDM_CONVERT 1
#define CDM_CONVERT351 2
#define CDM_DRIVER_DEFAULT 4

#define DRIVER_EVENT_INITIALIZE 3
#define DRIVER_EVENT_DELETE 2

#define PRINTER_EVENT_ADD_CONNECTION 1
#define PRINTER_EVENT_DELETE_CONNECTION 2
#define PRINTER_EVENT_INITIALIZE 3
#define PRINTER_EVENT_DELETE 4
#define PRINTER_EVENT_CACHE_REFRESH 5
#define PRINTER_EVENT_CACHE_DELETE 6
#define PRINTER_EVENT_ATTRIBUTES_CHANGED 7

#define PRINTER_EVENT_FLAG_NO_UI 1

#define DOCUMENTEVENT_FIRST
#define DOCUMENTEVENT_CREATEDCPRE 1
#define DOCUMENTEVENT_CREATEDCPOST 2
#define DOCUMENTEVENT_RESETDCPRE 3
#define DOCUMENTEVENT_RESETDCPOST 4
#define DOCUMENTEVENT_STARTDOC 5
#define DOCUMENTEVENT_STARTDOCPRE 5
#define DOCUMENTEVENT_STARTPAGE 6
#define DOCUMENTEVENT_ENDPAGE 7
#define DOCUMENTEVENT_ENDDOC 8
#define DOCUMENTEVENT_ENDDOCPRE 8
#define DOCUMENTEVENT_ABORTDOC 9
#define DOCUMENTEVENT_DELETEDC 10
#define DOCUMENTEVENT_ESCAPE 11
#define DOCUMENTEVENT_ENDDOCPOST 12
#define DOCUMENTEVENT_STARTDOCPOST 13
#define DOCUMENTEVENT_LAST 14

#define DOCUMENTEVENT_SPOOLED 0x00010000

#define DOCUMENTEVENT_FAILURE -1
#define DOCUMENTEVENT_SUCCESS 1
#define DOCUMENTEVENT_UNSUPPORTED 0

/* BOOL DDKAPI DrvPrinterEvent (LPWSTR, INT, DWORD, LPARAM); */
typedef BOOL DDKAPI (*PFN_DrvPrinterEvent)(LPWSTR, INT, DWORD, LPARAM);

/* LONG DDKAPI DrvDocumentPropertySheets(PPROPSHEETUI_INFO, LPARAM); */
typedef LONG DDKAPI (*PFN_DrvDocumentPropertySheets)(PPROPSHEETUI_INFO, LPARAM);

typedef BOOL DDKAPI (*PFN_DrvDriverEvent)(DWORD, DWORD, LPBYTE, LPARAM);
typedef INT DDKAPI (*PFN_DrvDocumentEvent)(HANDLE, HDC, int, ULONG, PVOID, ULONG, PVOID);

typedef DWORD DDKAPI (*PFN_DrvDeviceCapabilities)(HANDLE, PWSTR, WORD, VOID*, PDEVMODE);
typedef LONG DDKAPI (*PFN_DrvDevicePropertySheets)(PPROPSHEETUI_INFO, LPARAM);

typedef struct _DEVQUERYPRINT_INFO {
    WORD cbSize;
    WORD Level;
    HANDLE hPrinter;
    DEVMODE *pDevMode;
    LPTSTR pszErrorStr;
    DWORD cchErrorStr;
    DWORD cchNeeded;
} DEVQUERYPRINT_INFO, *PDEVQUERYPRINT_INFO;

typedef BOOL DDKAPI (*PFN_DevQueryPrintEx)(PDEVQUERYPRINT_INFO);
typedef BOOL DDKAPI (*PFN_DrvQueryColorProfile)(HANDLE, PDEVMODEW, ULONG, VOID*, ULONG*, FLONG*);
typedef BOOL DDKAPI (*PFN_DrvQueryJobAttributes)(HANDLE, PDEVMODE, DWORD, LPBYTE);
typedef DWORD DDKAPI (*PFN_DrvSplDeviceCaps)(HANDLE, LPTSTR, WORD, VOID*, DWORD, DEVMODE*);
typedef BOOL DDKAPI (*PFN_DrvUpgradePrinter)(IN DWORD Level, IN LPBYTE pDriverUpgradeInfo);



#ifdef __cplusplus
} /* extern "C" */
#endif

#endif /* __WINE_WINDDIUI_H */
